Attribute VB_Name = "BaseDonnees"
Option Explicit
Option Base 0

Public Function X_BD() As Double()
'
'----------------------------------------------------------------------------------------
' X_BD - Construction de Xaug  partir d'une base de donnes.
'----------------------------------------------------------------------------------------
'
' Cette fonction permet  partir de donnes stockes dans une base de donnes, de
' construire la matrice Xaug ncessaire au sous-programme Regression.
'
'----------------------------------------------------------------------------------------
'  2003 - Paul Salmon
'----------------------------------------------------------------------------------------
'
' Dclarations des variables locales
'
Dim Xmat() As Double               ' Matrice "Buffer"
Dim strQueryJoin As String         ' Chaine de caractres contenant la requte
Dim rstJoin As ADODB.Recordset     ' Recordset
Dim i As Long                      ' Indice de boucle
Dim j As Long                      ' Indice de boucle

Dim PremiereObs As Long            ' Numro de la premire observation
Dim DerniereObs As Long            ' Numro de la dernire observation
Dim NbObs As Long                  ' Nombre d'observations
Dim strJoin As String              ' Chaine de caractres contenant la requte
'
Dim MatInter() As Variant          ' Matrice Intermdiaire des donnes
Dim MatInterDat() As Variant       ' Matrice Intermdiaire des dates
'
' Cration du nouveau recordSet
'
Set rstJoin = New ADODB.Recordset
'
' Dfinition des requtes
'
'   Requte Join pour les donnes journalires
'
'       Cette requte permet de choisir pour toutes les dates de l'indice
'       les dones comprises entre les donnes disponibles du cours
'
strJoin = ""
strJoin = strJoin & "SELECT "
strJoin = strJoin & "[" & CoursSicovam & "]" & ".DateCotation As CoursDate, "
strJoin = strJoin & "[" & CoursSicovam & "]" & ".Cloture As CoursCloture, "
strJoin = strJoin & "[" & IndiceSicovam & "]" & ".DateCotation As IndiceDate, "
strJoin = strJoin & "[" & IndiceSicovam & "]" & ".Cloture As IndiceCloture "
strJoin = strJoin & "FROM " & CoursSicovam & " "
strJoin = strJoin & "RIGHT OUTER JOIN " & IndiceSicovam & " "
strJoin = strJoin & "ON " & "[" & CoursSicovam & "]" & ".DateCotation = "
strJoin = strJoin & "[" & IndiceSicovam & "]" & ".DateCotation "
'
If TypeDonnees = "TousLesJours" Then
'
    strJoin = strJoin & "WHERE [" & IndiceSicovam & "].DateCotation "
    strJoin = strJoin & "BETWEEN " & DateDeb & " AND " & DateFin & ";"
'
' Permet de choisir le jour de la semaine entre deux dates.
'
ElseIf TypeDonnees = "JourDeSemaine" Then
'
    strJoin = strJoin & "WHERE WEEKDAY([" & IndiceSicovam & "].DateCotation) = " & TypeJour & " "
    strJoin = strJoin & "AND [" & IndiceSicovam & "].DateCotation "
    strJoin = strJoin & "BETWEEN " & DateDeb & " AND " & DateFin & ";"
'
' Permet de choisir les cours du vendredi entre deux dates.
'
ElseIf TypeDonnees = "FinDeSemaine" Then
'
    strJoin = strJoin & "WHERE WEEKDAY([" & IndiceSicovam & "].DateCotation) = 6 "
    strJoin = strJoin & "AND [" & IndiceSicovam & "].DateCotation "
    strJoin = strJoin & "BETWEEN " & DateDeb & " AND " & DateFin & ";"
'
' Permet de choisir les cours de Fin de mois entre deux dates.
'
' ElseIf TypeDonnees = "FinDeSemaine"
'
    'strJoin = strJoin & "WHERE WEEKDAY([" & IndiceSicovam & "].DateCotation) = 5 "
    'strJoin = strJoin & "AND [" & IndiceSicovam & "].DateCotation "
    'strJoin = strJoin & "BETWEEN " & DateDeb & " AND " & DateFin & ";"
'
End If
'
Debug.Print strJoin
'
' Cration du RecordsSet correspondant  la requte ci-dessus.
'
rstJoin.Open strJoin, cnn, adOpenKeyset
'
' Redimensionnement des matrices en fonction du nombre de lignes du recordset.
'
Debug.Print " rstJoin.RecordCount = " & rstJoin.RecordCount
Debug.Print "DateDeb = " & DateDeb & " DateFin = " & DateFin
'
ReDim MatInter(0 To 1, 0 To rstJoin.RecordCount - 1)
ReDim MatInterDat(0 To 1, 0 To rstJoin.RecordCount - 1)
'
' Repositionnement du curseur sur le premier enregistrement
'
rstJoin.MoveFirst
'
For i = 0 To rstJoin.RecordCount - 1
    '
    ' Remplissage des matrices des donnes
    '
    If IsNull(rstJoin!IndiceCloture) = True Then
        MatInter(0, i) = -999999#
    Else
        MatInter(0, i) = rstJoin!IndiceCloture
    End If
    '
    If IsNull(rstJoin!CoursCloture) = True Then
        MatInter(1, i) = -999999#
    Else
        MatInter(1, i) = rstJoin!CoursCloture
    End If
    '
    ' Remplissage de la matrice des "dates"
    '
    If IsNull(rstJoin!IndiceDate) = True Then
        MatInterDat(0, i) = #1/1/1900#
    Else
        MatInterDat(0, i) = rstJoin!IndiceDate
    End If
    '
    If IsNull(rstJoin!CoursDate) = True Then
        MatInterDat(1, i) = #1/1/1900#
    Else
        MatInterDat(1, i) = rstJoin!CoursDate
    End If
    '
    ' Dplacement vers l'enregistrement suivant.
    '
    rstJoin.MoveNext
    '
Next i
'
' Dimensionnement et remplissage du vecteur DateVec utilis dans le Grid
'
ReDim DateVec(1 To rstJoin.RecordCount)
'
' Affectation des dates
'
For i = 1 To rstJoin.RecordCount
    '
    ' Affectation des dates dans le vecteur DateVec, pour affichage dans Grid
    '
    DateVec(i) = MatInterDat(0, i - 1)
    'Debug.Print "DateVec(" & i & ") = " & DateVec(i)
    '
Next i
'
'----------------------------------------------------------------------------------------
' Traitement des valeurs manquantes
'----------------------------------------------------------------------------------------
'
' Cas des donnes journalires (cas par dfaut)
'
'    La valeur manquante d'une observation est remplace par la valeur de la date
'   prcdente. (Cas des donnes journalires)
'
For i = 1 To rstJoin.RecordCount - 1
    If MatInter(1, i) = -999999 Then
        MatInter(1, i) = MatInter(1, i - 1)
    End If
    If MatInterDat(1, i) = #1/1/1900# Then
        MatInterDat(1, i) = MatInterDat(0, i)
    End If
Next i
'
'----------------------------------------------------------------------------------------
' Redimensionnement et remplissage de la matrice intermdiaire Xmat
'----------------------------------------------------------------------------------------
'
' Dimensionnement de la matrice Xaug
'
ReDim Xmat(0 To rstJoin.RecordCount - 2, 0 To 2)
'
' Ecriture des donnes dans la matrice.
'
For i = 1 To rstJoin.RecordCount - 1
    '
    ' j est introduit ici pour faire commencer la Xmat  0 dans ses dimensions.
    '
    j = i - 1
    '
    ' Constante
    '
    Xmat(j, 0) = 1#
    '
    ' Cas du taux de variation
    '
    If TypeTransformation = "TxVar" Then
        '
        ' Variable explicative (ici Taux de variation de l'indice)
        '
        Xmat(j, 1) = (CDbl(MatInter(0, i)) / CDbl(MatInter(0, i - 1))) - 1
        '
        ' Variable  expliquer (ici Taux de variation du cours)
        '
        Xmat(j, 2) = (CDbl(MatInter(1, i)) / CDbl(MatInter(1, i - 1))) - 1
        '
    ElseIf TypeTransformation = "DifLog" Then
        '
        ' Variable explicative (ici Diffrence des log de l'indice)
        '
        Xmat(j, 1) = Log(CDbl(MatInter(0, i))) - Log(CDbl(MatInter(0, i - 1)))
        '
        ' Variable  expliquer (ici Diffrence des Log du cours)
        '
        Xmat(j, 2) = Log(CDbl(MatInter(1, i))) - Log(CDbl(MatInter(1, i - 1)))
        '
    End If
    '
Next i
'
'----------------------------------------------------------------------------------------
' Affectation du contenu de la matrice "buffer"  X_BD
'----------------------------------------------------------------------------------------
'
X_BD = Xmat
'
'----------------------------------------------------------------------------------------
' Fin de la fonction X_BD
'----------------------------------------------------------------------------------------
'
End Function
