Attribute VB_Name = "BaseDonnees"
Option Explicit
Option Base 0

Public Function X_BD() As Double()
'
'----------------------------------------------------------------------------------------
' X_BD - Construction de Xaug  partir d'une base de donnes.
'----------------------------------------------------------------------------------------
'
' Cette fonction permet  partir de donnes stockes dans une base de donnes de
' la matrice Xaug ncessaire au sous-programme Regression.
'
'----------------------------------------------------------------------------------------
'  2003 - Paul Salmon
'----------------------------------------------------------------------------------------
'
' Arguments de la fonction
'
' NomBaseDeDonnees    ' Nom complet de la base de donnes. La base de donnes est
'                     ' en local
'
' Dclarations des variables locales
'
Dim Xmat() As Double               ' Matrice "Buffer"
Dim strQueryJoin As String         '
Dim rstJoin As ADODB.Recordset     '
Dim i As Long                      '
Dim j As Long

Dim PremiereObs As Long            '
Dim DerniereObs As Long            '
Dim NbObs As Long                  '
Dim strJoin As String              '
'
Dim MatInter() As Variant          '
Dim MatInterDat() As Variant       '

Set rstJoin = New ADODB.Recordset  '
'
' Dfinition des requtes
'
'   Requte Join
'

strJoin = ""
strJoin = strJoin & "SELECT "
strJoin = strJoin & "[" & CoursSicovam & "]" & ".DateCotation As CoursDate, "
strJoin = strJoin & "[" & CoursSicovam & "]" & ".Cloture As CoursCloture, "
strJoin = strJoin & "[" & IndiceSicovam & "]" & ".DateCotation As IndiceDate, "
strJoin = strJoin & "[" & IndiceSicovam & "]" & ".Cloture As IndiceCloture "
strJoin = strJoin & "FROM " & CoursSicovam & " "
strJoin = strJoin & "RIGHT OUTER JOIN " & IndiceSicovam & " "
strJoin = strJoin & "ON " & "[" & CoursSicovam & "]" & ".DateCotation = "
strJoin = strJoin & "[" & IndiceSicovam & "]" & ".DateCotation "
'
' Cration des RecordsSets
'
rstJoin.Open strJoin, cnn, adOpenKeyset
'
' Dtermination du nombre de ligne de la matrice
'
Debug.Print " rstJoin.RecordCount = " & rstJoin.RecordCount
ReDim MatInter(0 To 1, 0 To rstJoin.RecordCount - 1)
ReDim MatInterDat(0 To 1, 0 To rstJoin.RecordCount - 1)
'
rstJoin.MoveFirst
For i = 0 To rstJoin.RecordCount - 1
    '
    ' Remplissage avec les donnes
    '
    MatInter(0, i) = rstJoin!IndiceCloture
    MatInter(1, i) = rstJoin!CoursCloture
    '
    ' Remplissage avec les dates
    '
    MatInterDat(0, i) = rstJoin!IndiceDate
    MatInterDat(1, i) = rstJoin!CoursDate
    '
    ' Vrification des "Null"
    '
    If IsNull(MatInter(0, i)) = True Then
        MatInter(0, i) = -999999#
    End If
    If IsNull(MatInter(1, i)) = True Then
        MatInter(1, i) = -999999#
    End If
    If IsNull(MatInterDat(0, i)) = True Then
        MatInterDat(0, i) = #1/1/1900#
    End If
    If IsNull(MatInterDat(1, i)) = True Then
        MatInterDat(1, i) = #1/1/1900#
    End If
    '
    ' Dplacement vers l'enregistrement suivant.
    '
    rstJoin.MoveNext
    '
Next i
'
'
'
For i = 0 To rstJoin.RecordCount - 1
    '
    If MatInterDat(1, i) = DateDeb Then
        PremiereObs = i
    End If
    '
    If MatInterDat(1, i) = Datefin Then
        DerniereObs = i
        Exit For
    End If
Next i
'
' Date de dbut de fin
'
Debug.Print "Premiere Obs = " & PremiereObs & " DerniereObs = " & DerniereObs & " RecordCount - 1 = " & rstJoin.RecordCount - 1
'
' Traitement des donnes manquantes.
'
'   Cas du remplacement des donnes manquantes par la valeur du jour prcdent
'
NbObs = DerniereObs - PremiereObs + 1
Debug.Print "NbObs = " & NbObs

ReDim DateVec(0 To NbObs - 1)

For i = PremiereObs To DerniereObs
    If MatInter(1, i) = -999999 Then
        MatInter(1, i) = MatInter(1, i - 1)
    End If
    If MatInterDat(1, i) = #1/1/1900# Then
        MatInterDat(1, i) = MatInterDat(0, i)
    End If
    '
    ' Affectation des date dans le vecteur DateVec, pour affichage dans Grid
    '
    DateVec(i - PremiereObs) = MatInterDat(1, i)
    '
Next i
'
' Dimensionnement de la matrice Xaug
'
ReDim Xmat(0 To NbObs - 2, 0 To 2)
'
' Ecriture des donnes dans la matrice.
'
For i = 1 To NbObs - 1
    '
    ' J est introduit ici pour faire commencer la Xmat  0 dans ses dimensions.
    '
    j = i - 1
    '
    ' Constante
    '
    Xmat(j, 0) = 1#
    '
    ' Variable explicative (ici Taux de varaition de l'indice)
    '
    Xmat(j, 1) = (CDbl(MatInter(0, i + PremiereObs)) / CDbl(MatInter(0, i + PremiereObs - 1))) - 1
    '
    ' Variable  expliquer (ici Tax de variation du cours)
    '
    Xmat(j, 2) = (CDbl(MatInter(1, i + PremiereObs)) / CDbl(MatInter(1, i + PremiereObs - 1))) - 1
Next i
'
' Affectation du contenu de la matrice "buffer"  X_BD
'
X_BD = Xmat
'
'----------------------------------------------------------------------------------------
' Fin de la fonction X_BD
'----------------------------------------------------------------------------------------
'
End Function
