Attribute VB_Name = "Impression"
Option Explicit
Option Base 0

Public Function Affichage(MatCoef() As Double, StatReg() As Double, CrossCorrMat() As Double, _
                      VarCovMatrix() As Double, PartialDerivatesMatrix() As Double) As String
'
'-----------------------------------------------------------------------------------------
' ImpResReg - Impression des rsultats de la rgression
'-----------------------------------------------------------------------------------------
'   Objet : Ce sous-programme cre la chaine de caractres contenant tous les rsultats
'           calculs par le sous-programme Regression.
'-----------------------------------------------------------------------------------------
'   Version 1.0.0 - 19 Fvrier 2003
'-----------------------------------------------------------------------------------------
'  Fvrier 2003 - Paul Salmon
'-----------------------------------------------------------------------------------------
'
' Dclarations locales
'
Dim i As Long                   ' Indice de boucle
Dim j As Long                   ' Indice de boucle
'
' Lignes intermdiaires permettant de construire affichage
'
Dim Ligne0 As String            '
Dim Ligne1 As String            '
Dim Ligne2 As String            '
Dim Ligne3 As String            '
Dim Ligne4 As String            '
Dim Ligne5 As String            '
Dim Ligne6 As String            '
Dim Ligne7 As String            '
'
Dim LigneVarCov As String       '
Dim LignePD As String           '
Dim LigneCrossCorrMat As String '
Dim LigneTableauCoef As String  '
'
Dim LenToto As Long             '
Dim PosPoint As Long            '
'
Dim Titi(0 To 10) As String     '
Dim Toto() As String            '
Dim Intitule(0 To 9)            '
Dim Tutu                        '
'
Dim NombreDiese As Long         '
Dim Stringformat As String      '
Dim MaxPosPoint As Long         '
Dim MaxLen As Long              '
Dim FlagMoins As Boolean        '
Dim BlancSup As String          '

Dim Test() As String            '

Dim MaxLongueurAvantPoint() As Long                  '
ReDim MaxLongueurAvantPoint(0 To UBound(MatCoef, 2)) '
'
'----------------------------------------------------------------------------------------
' Dfinitions des lignes de titre et de sous-titres
'----------------------------------------------------------------------------------------
'
'   Traitement du tableau StatReg
'
ReDim Toto(0 To 10, 0 To 3)
'
For i = 0 To UBound(StatReg)
    Toto(i, 0) = CStr(Round(StatReg(i), 5))
    Toto(i, 1) = Len(Toto(i, 0))
    Toto(i, 2) = InStr(1, Toto(i, 0), ".", vbTextCompare)
    Toto(i, 3) = InStr(1, Toto(i, 0), "-", vbTextCompare)
Next i
'
For i = 0 To UBound(StatReg)
    Select Case i
        Case 0, 5, 10
            MaxPosPoint = 0
            For j = 0 To UBound(StatReg)
                If j = 0 Or j = 5 Or j = 10 Then
                    If Toto(j, 2) > MaxPosPoint Then
                        MaxPosPoint = Toto(j, 2)
                    End If
                End If
            Next j
            NombreDiese = MaxPosPoint - 1
            Stringformat = String(NombreDiese, "0") & ".00000"
            Titi(i) = Format(StatReg(i), Stringformat)
        Case 1, 6
            MaxPosPoint = 0
            For j = 0 To UBound(StatReg)
                If j = 1 Or j = 6 Then
                    If Toto(j, 2) > MaxPosPoint Then
                        MaxPosPoint = Toto(j, 2)
                    End If
                End If
            Next j
            NombreDiese = MaxPosPoint - 1
            Stringformat = String(NombreDiese, "0") & ".00000"
            Titi(i) = Format(StatReg(i), Stringformat)
        Case 2, 7
            MaxPosPoint = 0
            For j = 0 To UBound(StatReg)
                If j = 2 Or j = 7 Then
                    If Toto(j, 2) > MaxPosPoint Then
                        MaxPosPoint = Toto(j, 2)
                    End If
                End If
            Next j
            If Toto(i, 3) = 1 Then
                NombreDiese = MaxPosPoint - 2
                Stringformat = String(NombreDiese, "0") & ".00000"
            Else
                NombreDiese = MaxPosPoint - 2
                Stringformat = " " & String(NombreDiese, "0") & ".00000"
            End If
            Titi(i) = Format(StatReg(i), Stringformat)
        
        Case 3, 8
            MaxPosPoint = 0
            For j = 0 To UBound(StatReg)
                If j = 3 Or j = 8 Then
                    '
                    If Toto(j, 2) > MaxPosPoint Then
                        MaxPosPoint = Toto(j, 2)
                    End If
                    '
                    If MaxPosPoint = 0 Then
                        MaxPosPoint = 3
                    End If
                    '
                    If Toto(3, 1) >= Toto(8, 1) Then
                        If i = 3 Then
                            Stringformat = String(Toto(3, 1), "#")
                        Else
                            Stringformat = String(Toto(3, 1) - Toto(8, 1), " ") & String(Toto(8, 1), "#")
                        End If
                        '
                    ElseIf Toto(3, 1) < Toto(8, 1) Then

                        If i = 3 Then
                            Stringformat = String(Toto(8, 1) - Toto(3, 1), " ") & String(Toto(3, 1), "#")
                        Else
                            Stringformat = String(Toto(8, 1), "#")
                        End If
                        '
                    End If
                    '
                End If
            Next j
            '
            Titi(i) = Format(StatReg(i), Stringformat)
            '
        Case 4, 9
            MaxPosPoint = 0
            For j = 0 To UBound(StatReg)
                If j = 4 Or j = 9 Then
                    '
                    If Toto(j, 2) > MaxPosPoint Then
                        MaxPosPoint = Toto(j, 2)
                    End If
                    '
                    If MaxPosPoint = 0 Then
                        MaxPosPoint = 3
                    End If
                    '
                    If Toto(4, 1) >= Toto(9, 1) Then
                        If i = 4 Then
                            Stringformat = String(Toto(4, 1), "#")
                        Else
                            Stringformat = String(Toto(4, 1) - Toto(9, 1), " ") & String(Toto(9, 1), "#")
                        End If
                        '
                    ElseIf Toto(4, 1) < Toto(9, 1) Then
                        If i = 4 Then
                            Stringformat = String(Toto(9, 1) - Toto(4, 1), " ") & String(Toto(4, 1), "#")
                        Else
                            Stringformat = String(Toto(9, 1), "#")
                        End If
                        '
                    End If
                    '
                End If
            Next j
            '
            Titi(i) = Format(StatReg(i), Stringformat)
            '
    End Select
Next i
'
'
'
Ligne0 = " Rgression de Test pour les tudiants" & vbCrLf
Ligne1 = " SEE   = " & Titi(0) & " R2   = " & Titi(1) & " RHO = " & Titi(2) & " Obser  = " & Titi(3) & " A partir de " & Titi(4)
Ligne2 = " SEE+1 = " & Titi(5) & " RBSQ = " & Titi(6) & " DW  = " & Titi(7) & " DoFree = " & Titi(8) & "     Jusqu' " & Titi(9)
Ligne3 = " MAPE  = " & Titi(10)
'
' Initialisation de Intitule
'   Intitule est un tableau qui contient les intituls
'   des colonnes des rsultats des calculs sur les
'   coefficients estims.
'
Intitule(0) = "Nom de variable"
Intitule(1) = "Coef-Reg"
Intitule(2) = "Mexval"
Intitule(3) = "Elas"
Intitule(4) = "NorRes"
Intitule(5) = "Sigma"
Intitule(6) = "Moyenne"
Intitule(7) = "Beta"
Intitule(8) = "t-Student"
Intitule(9) = "F-Stat"
'
'
' Cration de la chane de caractres "Affichage"
'
Affichage = ""
Affichage = Affichage & Ligne0 & vbCrLf
Affichage = Affichage & Ligne1 & vbCrLf
Affichage = Affichage & Ligne2 & vbCrLf
Affichage = Affichage & Ligne3 & vbCrLf & vbCrLf
'
' Transformation de la matrice des nombres en une matrice contenant les nombres sous
' forme de chanes de caractres arrondis avec n dcimales.
'
Test = PrepMat(MatCoef(), NumberDecimal)
'
'
'
ReDim Toto(0 To UBound(Test, 1), 0 To UBound(Test, 2), 0 To 3)
'
' Affichage des coefficients et autres rsultats lis
'
For i = 0 To UBound(Test, 1)
    For j = 0 To UBound(Test, 2)
        '
        ' Contient la valeur de Test initiale
        '
        Toto(i, j, 0) = Test(i, j)
        '
        ' Longueur de la chane Test
        '
        Toto(i, j, 1) = Len(Toto(i, j, 0))
        '
        ' Position du point dcimal
        '
        Toto(i, j, 2) = InStr(1, Toto(i, j, 0), ".", vbTextCompare)
        '
        ' Poisition du signe "-"
        '
        Toto(i, j, 3) = InStr(1, Toto(i, j, 0), "-", vbTextCompare)
        '
        ' Dtermination de la taille maximale pour un j donn
        ' de la partie entire
        '
        If Toto(i, j, 2) > MaxLongueurAvantPoint(j) Then
            MaxLongueurAvantPoint(j) = Toto(i, j, 2)
        End If
    Next j
Next i
'
Ligne4 = " "
'
Dim TailleColonne() As Integer
ReDim TailleColonne(0 To UBound(Intitule))

For i = 0 To UBound(Intitule)
    If i = 0 Then
        '
        ' Cas de "Nom de variable"
        '
        Ligne4 = Ligne4 & Intitule(i) & Space(16 - Len(Intitule(i)))
        TailleColonne(i) = 0
        '
    Else
        '
        ' Cas pour les statistiques
        '
        If Len(Intitule(i)) >= MaxLongueurAvantPoint(i - 1) + NumberDecimal + 1 Then
            Tutu = Len(Intitule(i)) + 1
        'ElseIf Len(Intitule(i)) = (MaxLongueurAvantPoint(i - 1) + NumberDecimal + 1) Then
        '   Tutu = Len(Intitule(i))
        Else
            Tutu = MaxLongueurAvantPoint(i - 1) + NumberDecimal + 1
        End If
        '
        '
        '
        TailleColonne(i) = Tutu
        '
        ' Construction progressive de la "Ligne4"
        '
        Ligne4 = Ligne4 & Space(Tutu - Len(Intitule(i))) & Intitule(i)
        '
    End If
Next i
'
Affichage = Affichage & Ligne4 & vbCrLf
'
' Construction de la chane de caractres LigneTableaucoef
'
LigneTableauCoef = Space(18)
'
For i = 0 To UBound(Test, 1)
    For j = 0 To UBound(Test, 2)
        
        Toto(i, j, 0) = Space(TailleColonne(j + 1) - Len(Toto(i, j, 0)) - 1) & Toto(i, j, 0)
        
        '
        'If MaxLongueurAvantPoint(j) > Toto(i, j, 2) Then
        '    Toto(i, j, 0) = Space(MaxLongueurAvantPoint(j) - Toto(i, j, 2)) & Toto(i, j, 0)
        'End If
        '
        LigneTableauCoef = LigneTableauCoef & Toto(i, j, 0) & " "
        '
    Next j
    '
    LigneTableauCoef = LigneTableauCoef & vbCrLf & Space(18)
    '
Next i
'
' Ajout de LigneTableauCoef  Affichage
'
Affichage = Affichage & vbCrLf & LigneTableauCoef & vbCrLf
'
'----------------------------------------------------------------------------------------
' Affichage de la matrice de Variance-Covariance des coefficients
'----------------------------------------------------------------------------------------
'

Ligne5 = " Matrice de Variance-Covariance des coefficients de rgression"
'
Affichage = Affichage & Ligne5 & vbCrLf
'
' Transformation de la matrice des nombres en une matrice contenant les nombres sous
' forme de chanes de caractres arrondis avec n dcimales.
'
Dim NumBerDecimalVarCov As Integer
Dim Maxtest As Integer

NumBerDecimalVarCov = 3
Maxtest = 0

Test = PrepMat(VarCovMatrix(), NumBerDecimalVarCov)
'
' Recherche du nombre de plus grande taille
'
For i = 0 To UBound(VarCovMatrix, 1)
    For j = 0 To UBound(VarCovMatrix, 1)
        If Len(Test(i, j)) > Maxtest Then
            Maxtest = Len(Test(i, j))
        End If
    Next j
Next i
'
For i = 0 To UBound(VarCovMatrix, 1)
    For j = 0 To UBound(VarCovMatrix, 2)
        LigneVarCov = LigneVarCov & Space(Maxtest - Len(Test(i, j))) & Test(i, j) & " "
    Next j
    LigneVarCov = LigneVarCov & vbCrLf
Next i
'
'
'
Affichage = Affichage & LigneVarCov & vbCrLf
'
'----------------------------------------------------------------------------------------
' Affichage de la matrice des drivs partielles
'----------------------------------------------------------------------------------------
'
Ligne6 = " Drives partielles des coefficients de rgression les uns par rapport aux autres"
'
Affichage = Affichage & Ligne6 & vbCrLf
'
' Transformation de la matrice des nombres en une matrice contenant les nombres sous
' forme de chanes de caractres arrondis avec n dcimales.
'
Dim NumBerDecimalPD As Integer

NumBerDecimalPD = 3
Maxtest = 0

Test = PrepMat(PartialDerivatesMatrix(), NumBerDecimalPD)
'
' Recherche du nombre de plus grande taille
'
For i = 0 To UBound(PartialDerivatesMatrix, 1)
    For j = 0 To UBound(PartialDerivatesMatrix, 1)
        If Len(Test(i, j)) > Maxtest Then
            Maxtest = Len(Test(i, j))
        End If
    Next j
Next i
'
For i = 0 To UBound(PartialDerivatesMatrix, 1)
    For j = 0 To UBound(PartialDerivatesMatrix, 2)
        LignePD = LignePD & Space(Maxtest - Len(Test(i, j))) & Test(i, j) & " "
    Next j
    LignePD = LignePD & vbCrLf
Next i
'
Affichage = Affichage & LignePD & vbCrLf
'
'----------------------------------------------------------------------------------------
' Affichage de la matrice de corrlation croise et des cart-types
'----------------------------------------------------------------------------------------
'
Ligne7 = " Ecrat-Type et matrice des coerrlations croises"
'
Affichage = Affichage & Ligne7 & vbCrLf
'
'
' Transformation de la matrice des nombres en une matrice contenant les nombres sous
' forme de chanes de caractres arrondis avec n dcimales.
'
Dim NumBerDecimalCrossCorr As Integer

NumBerDecimalCrossCorr = 3
Maxtest = 0

Test = PrepMat(CrossCorrMat(), NumBerDecimalPD)
'
' Recherche du nombre de plus grande taille
'
For i = 0 To UBound(CrossCorrMat, 1)
    For j = 0 To UBound(CrossCorrMat, 2)
        If Len(Test(i, j)) > Maxtest Then
            Maxtest = Len(Test(i, j))
        End If
    Next j
Next i
'
For i = 0 To UBound(CrossCorrMat, 1)
    For j = 0 To UBound(CrossCorrMat, 2)
        LigneCrossCorrMat = LigneCrossCorrMat & Space(Maxtest - Len(Test(i, j))) & Test(i, j) & " "
    Next j
    LigneCrossCorrMat = LigneCrossCorrMat & vbCrLf
Next i
'
'Dim MaxCrossCorrMat
'For i = 1 To UBound(CrossCorrMat, 1)
'    For j = 1 To UBound(CrossCorrMat, 2)
'        If Len(CStr(CrossCorrMat(i, j))) > MaxCrossCorrMat Then
'            MaxCrossCorrMat = Len(CStr(CrossCorrMat(i, j)))
'        End If
'    Next j
'Next i
''Debug.Print "MaxCrossCorrMat = " & MaxCrossCorrMat
'For i = 1 To UBound(CrossCorrMat, 1)
'    For j = 1 To UBound(CrossCorrMat, 2)
'        LigneCrossCorrMat = LigneCrossCorrMat & Format(CrossCorrMat(i, j), "#0.00000") & " "
'    Next j
'    LigneCrossCorrMat = LigneCrossCorrMat & vbCrLf
'Next i
'
'
'
Affichage = Affichage & LigneCrossCorrMat & vbCrLf
'
'----------------------------------------------------------------------------------------
' Fin du sous-programme d'criture des rsultats de la rgression.
'----------------------------------------------------------------------------------------
'
End Function

Public Function PrepMat(MatCoef() As Double, NbDecimaleApresPoint As Integer) As String()
'
'----------------------------------------------------------------------------------------
' PrepMat - Prparation des donnes sous diverses formes pour la publications
'----------------------------------------------------------------------------------------
'
'----------------------------------------------------------------------------------------
'  Copyright 2003 - Paul Salmon
'----------------------------------------------------------------------------------------
'
Dim Tata As String
Dim PosMoins As Long
Dim PosPointDecimal As Long
Dim PosE As Long
Dim NbDecimales As Long
Dim LenTata As Long
Dim PartieDecimale As String
Dim PartieE As String
Dim PartieEntiere As String
Dim Test() As String
Dim i
Dim j
'
' Dimensionnement des matrices.
'
ReDim PreMat(0 To UBound(MatCoef, 1), 0 To UBound(MatCoef, 2))
ReDim Test(0 To UBound(MatCoef, 1), 0 To UBound(MatCoef, 2))
'
'
'
For i = 0 To UBound(MatCoef, 1)
    For j = 0 To UBound(MatCoef, 2)
        '
        ' Informations de base sur les nombres  traiter
        '
        Tata = CStr(Round(MatCoef(i, j), NbDecimaleApresPoint))
        '
        ' Caractristiques de la chane  traiter
        '
        '   Longueur de la chane
        '
        LenTata = Len(Tata)
        '
        '   Emplacement du premier moins  (Cas du type E-02)
        '
        PosMoins = InStr(1, Tata, "-", vbTextCompare)
        '
        '   Emplacement du "." dans la chane de caratactres
        '
        PosPointDecimal = InStr(1, Tata, ".", vbTextCompare)
        '
        ' Dtermination du nombre de dcimales
        '
        If PosPointDecimal <> 0 Then
            NbDecimales = LenTata - PosPointDecimal
        Else
            NbDecimales = 0
        End If
        '
        ' Construction de la partie dcimale
        '
        If NbDecimales >= NbDecimaleApresPoint Then
                PartieDecimale = Mid(Tata, PosPointDecimal, 1 + NbDecimaleApresPoint)
        ElseIf NbDecimales > 0 And NbDecimales < NbDecimaleApresPoint Then
                PartieDecimale = Mid(Tata, PosPointDecimal, 1 + NbDecimales) & String(NbDecimaleApresPoint - NbDecimales, "0")
        ElseIf NbDecimales = 0 Then
            PartieDecimale = "." & String(NbDecimaleApresPoint, "0")
        End If
        '
        ' Construction de la partie entire
        '
        If PosPointDecimal <> 0 Then
            PartieEntiere = Mid(Tata, 1, PosPointDecimal - 1)
        Else
            PartieEntiere = Tata
        End If
        '
        Test(i, j) = PartieEntiere & PartieDecimale
        '
    Next j
Next i
PrepMat = Test
'
'----------------------------------------------------------------------------------------
' Fin de la fonction PrepMat
'----------------------------------------------------------------------------------------
'
End Function

