Attribute VB_Name = "Principal"
Option Explicit
'
'----------------------------------------------------------------------------------------
'   Module Principal
'----------------------------------------------------------------------------------------
'
'   Ce module ne contient que deux sous-programmes : Main et Configuration.
'
'   Main contient l'appel aux diffrents sous-programmes et fonction ainsi que certains
'   appels  diffrentes formes.  Sa principal tache est d'appeler le sous-programme
'   Configuration.
'
'   Configuration sert  personnaliser l'application en focntion du got et de
'   l'organisation de la machine d'un utilisateur.
'
'----------------------------------------------------------------------------------------
'    2003-2006 - Paul Salmon
'----------------------------------------------------------------------------------------
'

Private Sub Main()
'
'----------------------------------------------------------------------------------------
'   Sous-programme Main
'----------------------------------------------------------------------------------------
'
'   Dans le cas prsent, Main permet de grer les taches les unes aprs les autres.
'
'   Cette xcution squentielle des taches est suivi  l'aide de frmExecution.
'
'----------------------------------------------------------------------------------------
'    2004-2006 Paul Salmon
'----------------------------------------------------------------------------------------
'
'   Affichage de la fentre de suivi d'excution.
'
frmExecution.Show
'
'   Lecture du fichier de configuration
'
frmExecution.Taches(0).Visible = True
Configuration
'
'   Rapatriement du fichier compress  partir du site de FRED
'
frmExecution.Taches(1).Visible = True
Rapatriement
'
'   Dcompression du fichier compress provenant de FRED
'
frmExecution.Taches(2).Visible = True
Decompression
'
'   Liste des fichiers
'
frmExecution.Taches(3).Visible = True
ListeFichiers strDonnees
'
' Cration de la base de donnes
'
frmExecution.Taches(4).Visible = True
frmExecution.ProgressBar1.Visible = True
CreationBD
'
' Traitement des fichiers
'
frmExecution.Taches(5).Visible = True
frmExecution.ProgressBar2.Visible = True
Traitement
'
' Fin du travail
'
frmExecution.Taches(6).Visible = True
'
If FinAutomatique = True Then
    End
Else
    frmExecution.Command1.Visible = True
End If
'
' Fin du sous programme
'
End Sub

Public Sub Configuration()
'
'----------------------------------------------------------------------------------------
'   Sous-programme Configuration
'----------------------------------------------------------------------------------------
'
'   Permet de lire et d'affecter  diverses variables les valeurs des variables dfinies
'   par l'utilisateur dans le fichier texte config.cfg qui se trouve dans le dossier de
'   l'application.
'
'----------------------------------------------------------------------------------------
'    2004-2006 Paul Salmon
'----------------------------------------------------------------------------------------
'
'
' Dclarations locales
'
Dim NomFichierConfig As String  ' Nom complet du fichier de configuration
Dim NumFichierConfig As Integer ' Numro du fichier de configuration
Dim LigneLue As String          ' Buffer contenant les caractres de la ligne lue
Dim NumeroDeLigne As Integer    ' Numro de la ligne en cours de traitement
Dim TableLigne() As String      ' Tableau contenant les informations des diverses lignes
'
' Lecture du fichier de configuration et affectation des valeurs des variables
'
LecteurDeTravail = Mid$(App.Path, 1, 1)
'
'
'
Debug.Print "Dbut du programme" & vbCrLf & String$(18, "_")
Debug.Print "App.Path = " & App.Path
Debug.Print "Lecteur de Travail = " & LecteurDeTravail
'
NomFichierConfig = App.Path & "\Config.cfg"
NumFichierConfig = FreeFile
'
' ouverture du fichier de configuration
'
Open NomFichierConfig For Input As NumFichierConfig
'
' Lecture du fichier et traitement des lignes
'
NumeroDeLigne = 0
Do While Not EOF(NumFichierConfig)
    '
    ' Lecture de la ligne dans le fichier
    '
    Line Input #NumFichierConfig, LigneLue
    '
    ' Dtermination si la ligne est une ligne de commentaire
    '
    If InStr(1, LigneLue, "#", vbTextCompare) = 0 Then
        '
        ' Incrmentation du numro de la ligne
        '
        NumeroDeLigne = NumeroDeLigne + 1
        '
        ' Transformation de la ligne dlimite en un tableau
        '
        TableLigne = Split(LigneLue, ";", -1, vbTextCompare)
        '
        '   Ecrit dans la fentre "Execution" - Phase de test
        '
        Debug.Print TableLigne(0)
        Debug.Print TableLigne(1)
        '
        ' Initialisation des variables.
        '
        Debug.Print "Numro de Ligne = " & NumeroDeLigne
        '
        '   Affectation des valeurs au variables en fonction de leurs positions dans le
        '   fichier de configuration.
        '
        Select Case NumeroDeLigne
            Case 1
                strURL = Trim$(TableLigne(1))
            Case 2
                strDonnees = Trim$(TableLigne(1))
            Case 3
                strBaseDeDonnees = Trim$(TableLigne(1))
            Case 4
                strFichiersExcel = Trim$(TableLigne(1))
            Case 5
                strDecompression = RechercheBackSlash(Trim$(TableLigne(1)))
            Case 6
                Temporisation_en_Secondes = CInt(Trim$(TableLigne(1)))
            Case 7
                NombreCaracteres.Country = CInt(Trim$(TableLigne(1)))
            Case 8
                NombreCaracteres.Title = CInt(Trim$(TableLigne(1)))
            Case 9
                NombreCaracteres.SeriesID = CInt(Trim$(TableLigne(1)))
            Case 10
                NombreCaracteres.Source = CInt(Trim$(TableLigne(1)))
            Case 11
                NombreCaracteres.Release = CInt(Trim$(TableLigne(1)))
            Case 12
                NombreCaracteres.Seasonal = CInt(Trim$(TableLigne(1)))
            Case 13
                NombreCaracteres.Frequency = CInt(Trim$(TableLigne(1)))
            Case 14
                NombreCaracteres.Units = CInt(Trim$(TableLigne(1)))
            Case 15
                NombreCaracteres.Date = CInt(Trim$(TableLigne(1)))
            Case 16
                NombreCaracteres.LastUpdate = CInt(Trim$(TableLigne(1)))
            Case 17
                NombreCaracteres.Note = CInt(Trim$(TableLigne(1)))
            Case 18
                If UCase$(Trim$(TableLigne(1))) = "NON" Then
                    FinAutomatique = False
                Else
                    FinAutomatique = True
                End If
        End Select
    End If
Loop
'
'   Ecrit dans la fentre "Execution"
'
Debug.Print "strURL = " & strURL
Debug.Print "strDonnees = " & strDonnees
Debug.Print "strBaseDeDonnees = " & strBaseDeDonnees
Debug.Print "strFichiersExcel = " & strFichiersExcel
Debug.Print "strDecompression = " & strDecompression
Debug.Print "NombreCaracteres.Country = " & NombreCaracteres.Country
Debug.Print "NombreCaracteres.Title = " & NombreCaracteres.Title
Debug.Print "NombreCaracteres.SeriesID = " & NombreCaracteres.SeriesID
Debug.Print "NombreCaracteres.Source = " & NombreCaracteres.Source
Debug.Print "NombreCaracteres.Release = " & NombreCaracteres.Release
Debug.Print "NombreCaracteres.Seasonal = " & NombreCaracteres.Seasonal
Debug.Print "NombreCaracteres.Frequency = " & NombreCaracteres.Frequency
Debug.Print "NombreCaracteres.Units = " & NombreCaracteres.Units
Debug.Print "NombreCaracteres.Date = " & NombreCaracteres.Date
Debug.Print "NombreCaracteres.LastUpdate = " & NombreCaracteres.LastUpdate
Debug.Print "NombreCaracteres.Note = " & NombreCaracteres.Note
'
'
'----------------------------------------------------------------------------------------
' Fin du sous-programme Configuration
'----------------------------------------------------------------------------------------
'
End Sub

