Attribute VB_Name = "Taches"
Option Explicit
'
'----------------------------------------------------------------------------------------
'   Module Taches
'----------------------------------------------------------------------------------------
'
'   Ce module contient tous les sous-programmes et fonctions correspondant 
'   une phase du travail  raliser.
'
'   Le travail ralis par ce projet consiste  construire une base de donnes  partir
'   de donnes accessibles sur le site FRED de la Federal Reserve de Saint Louis.
'   Compte tenu de la taille de la base de donnes, il nous a sembl inutile de faire
'   un sous programme de mise  jour de la base de donnes. Pour tre mise  jour, la
'   base de donnes sera simplement reconstruite  intervalle plus ou moins rgulier.
'
'   Il a comme contrainte de pouvoir faire son travail sans intervention d'un individu,
'   et donc de pouvoir tre lanc automatiquement  partir par exemple de planificateur
'   de taches de Windows.
'
'   La version propose ici ne fait appel qu' des connaissances de base de Visual Basic
'   et de programmation.
'
'   Il est trs possible d'en faire des versions plus performantes. Si vous avez des
'   ides ne vous gnez pas.
'
'   Ce module contient, en dehors de Main et de Configuration, les sous-programmes et
'   fonctions suivants :
'
'   Rapatriement    : Ce sous porgramme permet de rapatrier le fichier .Zip contenant les
'                     donnes au format .TXT et de le stocker sur le disque.
'
'   Dcompression   : Comme son nom l'indique, ce sous-programme dcompresse le fichier
'                     rapatrier par le sous programme prcdent.
'
'   ListeFichiers   : Afin de pouvoir crer les tables dans la base de donnes, il est
'                     prfrable d'tablir la liste totale de tous les fichiers. Dans ce
'                     travail nous avons suppos que chaque fichier .TXT contenant une
'                     srie devait correspondra dnas notre base de donnes  une table.
'
'   CreationBD      : Dans tous les cas, il faut crer la base de donnes. Ici elle est
'                     par programmation.  Les informations de bases pour la construire
'                     sont bases sur le contenu des divers fichiers contenant les donnes.
'                     Dans notre cas une partie de cette information a t obtenue par le
'                     sous-programme Liste_Fichiers
'
'   Traitement      : L'objectif de traitement est triple : lire les fichiers, prparer les
'                     donnes et les introduire dans les tables de la base de donnes.
'
'----------------------------------------------------------------------------------------
'    2003-2006 Paul Salmon
'----------------------------------------------------------------------------------------
'

Public Sub CreationBD()
'
' Cration de la base de donnes
'
'----------------------------------------------------------------------------------------
' CreationBD - Version 1.0.0. - Mars 2005
'----------------------------------------------------------------------------------------
'
' Cration de la structure de la base de donnes en fonction des informations contenues
' dans le fichier de configuration et de la liste des fichiers provenant de la fonction
' ListeFichiers.
'
'----------------------------------------------------------------------------------------
'    2005-2006 - Paul Salmon
'----------------------------------------------------------------------------------------
'
' Dclaration des variables locales
'
'   Dclarations des variables lies  la base de donnes
'
Dim cat As New ADOX.Catalog     ' Cration d'un nouvel objey catalogue
Dim tbl As New ADOX.Table       ' Cration d'un nouvel objet tabble
'
'   Dclarations des autres variables
'
Dim CompteurLigne As Long       ' Contient le nombre de lignes
Dim i As Integer                ' Contient
Dim NomTable() As String        ' Contient tous les noms des fichiers contenus dans le .Zip
Dim RetVal As Integer           ' Contient la valeur de retour du Shell
Dim strProvider As String       ' Contient la chane de caractres permettant la cration
                                ' de la base de donnes et sa connexion.
'
' Test Passage Argument
'
NomDuFichierDeLaBaseDeDonnees = App.Path & "\EconData.mdb" 'Mettre le nom de la base de donnes dans le Config.cfg
'
' Destruction de la base de donnes si une existante
'
On Error Resume Next
    Kill NomDuFichierDeLaBaseDeDonnees
On Error GoTo 0
'
' Cration de la base de donnes
'
strProvider = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source= " & NomDuFichierDeLaBaseDeDonnees & _
              ";Jet OLEDB:Engine Type = 5;"
cat.Create strProvider
'
' Cration des tables de la base de donnes en fonction du contenu du fichier de
' configuration
'
'   Cration de la de la table intitule "SERIESmeta"
'
'       SERISmeta contient toutes les informations sur les sries contenues dans la
'       premire partie de chaque fchier.  Cette table premettra de faire des
'       vrifications sur les date de dbut et de fin de chaque srie,
'       de sa priodicit, etc.
'
Set tbl = New ADOX.Table
tbl.Name = "SERIESmeta"
    tbl.Columns.Append "Country", adVarWChar, NombreCaracteres.Country
    tbl.Columns.Append "Title", adVarWChar, NombreCaracteres.Title
    tbl.Columns.Append "SeriesID", adVarWChar, NombreCaracteres.SeriesID
    tbl.Columns.Append "Source", adVarWChar, NombreCaracteres.Source
    tbl.Columns.Append "Release", adVarWChar, NombreCaracteres.Release
    tbl.Columns.Append "Seasonal", adVarWChar, NombreCaracteres.Seasonal
    tbl.Columns.Append "Frequency", adVarWChar, NombreCaracteres.Frequency
    tbl.Columns.Append "Units", adVarWChar, NombreCaracteres.Units
    tbl.Columns.Append "Date", adVarWChar, NombreCaracteres.Date
    tbl.Columns.Append "Date_First", adDate
    tbl.Columns.Append "Date_Last", adDate
    tbl.Columns.Append "LastUpdate", adVarWChar, NombreCaracteres.LastUpdate
    tbl.Columns.Append "Note", adLongVarWChar, NombreCaracteres.Note
cat.Tables.Append tbl
'
'   Lecture du contenu du fichier
'
NomTable = ListeFichiers(strDonnees)
'
'   Initialisation de la ProgressBar
'
frmExecution.ProgressBar1.Value = LBound(NomTable)
frmExecution.ProgressBar1.Max = UBound(NomTable)
frmExecution.ProgressBar1.Min = LBound(NomTable)
'
'   Boucle permettant de crer toutes les tables correspondants chacune  un fichier en .TXT
'
For i = LBound(NomTable) To UBound(NomTable)
    '
    ' Boucle de cration de chaque table de cours contenue dans le fichier de configuration
    '
    '   Permet  l'ordinateur d'effectuer plusieurs taches en apparence simultanment.
    '
    DoEvents
    '
    ' Cration du nom de la table
    '
    '   Cration d'une nouvelle table dans la base de donnes.
    '
    Set tbl = New ADOX.Table
        '
        '   Construction du nom de la table.  Nomtable(i) contient l'extension du fichier
        '   d'o le "-4" dans la ligne ci-dessous. Le 4 correspond au nombre de caractres
        '   de la chane ".TXT".
        '
        tbl.Name = "US_" & Left$(NomTable(i), Len(NomTable(i)) - 4)
        '
        '   Vrification dans la fentre excution de la construction du nom de la table.
        '   (phase de test)
        '
        Debug.Print tbl.Name
        '
        tbl.Columns.Append "Date", adDate
        tbl.Columns.Append "Value", adSingle
    cat.Tables.Append tbl
    '
    ' Calcul du pourcentage de fichiers traits par rapport  l'ensemble
    ' (Affichage dans la ProgressBar1)
    '
    frmExecution.ProgressBar1.Value = i
    '
    ' Permets  l'ordinateur d'effectuer plusieurs taches en apparence simultanment.
    '
    DoEvents
    '
    ' Fin de la boucle de cration des tables dans la base de donnes.
    '
Next i
'
'   Libration des ressources "mmoire" et "systme" associes  l'objet.
'
Set tbl = Nothing
Set cat = Nothing
'
'----------------------------------------------------------------------------------------
' Fin du sous-programme de cration de la base de donnes
'----------------------------------------------------------------------------------------
'
End Sub

Public Sub Decompression()
'
'----------------------------------------------------------------------------------------
' Decompression - Dcompresser un fichier ZIP  l'aide de PKUNZIP de PKWARE
'----------------------------------------------------------------------------------------
'
'   Ce sous programme permet de dcompresser un ou des fichiers au format ZIP.
'
'   La syntaxe utilise dans ChaineShell est explique dans l'aide en ligne de PACL
'
'   Pour se procurer, les outils de compression et de dcompression de PowerArchiver
'   Command Line aller sur le site : http://www.powerarchiver.com/ et rechercher la
'   version ligne de commande.
'
'   Plusieurs variantes de ce sous-programme pourraient tre crites.
'   Considrez celle-ci comme pdagogique et deamndant peut de connaissance.
'
'----------------------------------------------------------------------------------------
'  2003-2005 - Paul Salmon
'----------------------------------------------------------------------------------------
'
' Dclarations des variables locales
'
Dim ChaineShell As String       ' Contient la chaine permettant la dcompression
Dim RetVal As Long              ' Contient la valeur retourne par le Shell
'
' Passage du dossier o se trouve l'excutable au dossier des donnes
'
ChDrive LecteurDeTravail
ChDir App.Path & "\" & strDonnees
'
' Cration de la chane de caractres contenant la commande de dcompression
'
strDecompression = RechercheBackSlash(strDecompression)
ChaineShell = strDecompression & "paext.exe -o+ *.zip"



   'Sub Form_Click()
   '   Dim retval As Long
   '   retval = ExecCmd("notepad.exe")
   '   MsgBox "Le processus est termin, code de sortie" & retval
   'End Sub

'
'   Ecrit dans la fentre "Execution" - Phase de test
'
Debug.Print "ChaineShell = " & ChaineShell
'
' Excution de la commande prcdente
'
RetVal = ExecCmd(ChaineShell)
'
'   Ecrit dans la fentre "Execution" - Phase de test
'
Debug.Print "Le processus est termin, code de sortie" & RetVal
'
'   Temporisation
'
'       Appel de la fonction contenue dans Utilitaires.
'
'Temporisation Temporisation_en_Secondes
'
' Destruction des fichiers inutiles
'
' Il faut mieux grer les destruction des fichiers. Il apparat au travers des tests que
' les deux tches Kill sont  rtudier.
' Pour l'instant, pour contrecarrer ce problme j'ai augmente le temps de la temporisation
'  120 secondes. Ce dlai peut-tre modifi en fonction de votre machine en plus ou en
' moins dans le fichier de configuration.
'
Kill "*.zip"        ' Une fois dcompress le fichier .zip rapatri ne nous sert plus  rien
Kill "readme*.txt"  ' Les fichiers en "readme" contiennent des informations qui ne nous sont
                    ' pas utiles dans le cadre de notre travail.
'
' Retour au dossier o se trouve l'excutable
'
ChDir App.Path
'
'----------------------------------------------------------------------------------------
' Fin du sous-programme
'----------------------------------------------------------------------------------------
'
End Sub

Public Function ListeFichiers(DossierDonnees As String) As String()
'
'----------------------------------------------------------------------------------------
'   Fonction ListeFichiers
'----------------------------------------------------------------------------------------
'
'   ListeFichiers est une fonction qui permet de faire la liste sous forme de tableau
'   de tous les fichiers contenus dans le fichier .ZIP rapatri.
'
'   La fonction retourne un tableau de chane de caractres.
'
'----------------------------------------------------------------------------------------
'    2003-2006 Paul Salmon
'----------------------------------------------------------------------------------------
'
'   Ecrit dans la fentre excution - Phase de test.
'
Debug.Print "Je suis dans ListeFichiers"
'
'   Dclarations locales
'
Dim TableauFichiers() As String     ' Tableau contenant tous les noms des fichiers
Dim NomFichier As String            ' Contient le nom du fichier
Dim CompteurFichiers As Integer     ' Contient le nombre de fichier traiter
Dim strFichierRecherche As String   ' Contient la chaine de caractres permettant la
                                    ' recherche  l'aide de la fonction "Dir" des noms
                                    ' de fichier.
Dim NbMaxFichiers As Integer        ' Nombre maximum de fichiers dans le dossier
Dim NbMinFichiers As Integer        ' Nombre maximum de fichiers dans le dossier
'
'   Redimensionnement du tableau
'
ReDim TableauFichiers(0)            '
'
'   Affectation de la chne de caractres de recherche.
'
strFichierRecherche = App.Path & "\" & DossierDonnees & "\*.txt"
'
'   Ecrit dans la fentre Excution - Phase de test
'
Debug.Print strFichierRecherche
'
'   Recherche du premier nom de fichier contenu dans le dossier.
'
NomFichier = Dir(strFichierRecherche)
TableauFichiers(0) = NomFichier
'
'   Initialisation  0 du compteur de fichier.
'
CompteurFichiers = 0
'
'   Boucle pour affecter tous les noms de fichier dans Tableaufichiers
'
Do While NomFichier <> ""
    '
    '   Affectation d'un nom de fichier lu dans le dossier
    '
    NomFichier = Dir
    '
    '   Sortie de la boucle DO dans le cas o la chane de caractres est vide.
    '
    If NomFichier = "" Then
        Exit Do
    End If
    '
    '   Incrmentation du compteur.
    '
    CompteurFichiers = CompteurFichiers + 1
    '
    '   Redimensionnement dynamique de TableauFichiers avec conservation du contenu
    '   du tableau.
    '
    ReDim Preserve TableauFichiers(CompteurFichiers)
    '
    '   Affectation du NomFichier au TableauFichiers.
    '
    TableauFichiers(CompteurFichiers) = NomFichier
    '
    '   Ecrit dans la fentre Execution - Phase de test.
    '
    Debug.Print "TableauFichiers(" & CompteurFichiers & ")= " & TableauFichiers(CompteurFichiers)
    '
Loop
'
'   Ecrit dans la fentre Excution - Phase de test.
'
Debug.Print TableauFichiers(0) & " " & TableauFichiers(UBound(TableauFichiers))
'
'   Affectation  ListeFichiers du contenu du tableau Tableaufichiers.
'
ListeFichiers = TableauFichiers
'
'
'----------------------------------------------------------------------------------------
'   Fin de la fonction ListeFichiers.
'----------------------------------------------------------------------------------------
'
End Function

Public Sub Rapatriement()
'
'----------------------------------------------------------------------------------------
' Telechargement - Rapatriement des donnes de FRED
'----------------------------------------------------------------------------------------
'
' Ce sous-programme est directement driv de l'exemple de l'aide en ligne de VB6, dans la
' rubrique Internet Transfer Control.
'
' Je l'ai tout simplement adapter  mon propos.
'
'----------------------------------------------------------------------------------------
'  2003-2006 - Paul Salmon
'----------------------------------------------------------------------------------------
'
' Initialisation des paramtres
'
Conteneur.Inet1.AccessType = icUseDefault
'
' Dclarations des variables locales
'
Dim b() As Byte                     '
Dim FichierSauvegarde As String     '
Dim NumFichierSauvegarde As Integer '
'
'   Ecrit dans la fentre Excution - Phase de test
'
Debug.Print "strURL = " & strURL
'
' Rcupre le fichier dans un tableau d'octets.
'
b() = Conteneur.Inet1.OpenURL("http://research.stlouisfed.org/fred2/downloaddata/FRED2_txt_2.zip", icByteArray)
'
' Affectation automatique d'un numro disponible
'
NumFichierSauvegarde = FreeFile
'
' Cration du nom du fichier  partir des informations de InfoFic
'
FichierSauvegarde = App.Path & "\" & strDonnees & "\Toto.zip"
Debug.Print FichierSauvegarde
'
' Ouverture du fichier o seront stockes les donnes rapatries
'
Open FichierSauvegarde For Binary Access Write As #NumFichierSauvegarde
'
' Ecriture des information dans le fichier
'
Put #NumFichierSauvegarde, , b()
'
' Fermeture du fichier
'
Close #NumFichierSauvegarde
'
'   Ecrit dans la fentre excution.
'
Debug.Print "Lecteur Actuel = " & CurDir$(LecteurDeTravail)
Debug.Print "Je sort de Rapatriement"
'
'----------------------------------------------------------------------------------------
' Fin du sous-programme
'----------------------------------------------------------------------------------------
'
'
End Sub

Public Sub Traitement()
'
'----------------------------------------------------------------------------------------
'   Sous-programme Traitement
'----------------------------------------------------------------------------------------
'
'   Partir des donnes de FRED II pour les introduire dans une base de donnes.
'   dans un premier temps de type Access.  Il est prvu de le faire ensuite pour
'   MySQL et SQL Server
'
'   Pour fonctionner, ce sous-programme utilise la fonction Intitule contenu dans
'   le module Utilitaires.
'
'----------------------------------------------------------------------------------------
'    2003-2006 Paul Salmon
'----------------------------------------------------------------------------------------
'
' Dclarations des variables locales.
'
Dim NomFichierTXT_Complet As String ' Nom du fichier TXT mais avec le chemin complet
'
Dim Premier As Boolean          ' Cas de la lecture du premier fichier  traiter
Dim NomFichierTXT As String     ' Nom du fichier TXT  traiter
Dim strPath As String           ' Contient le chemin d'accs au fichier
Dim NumFichierTxt As Integer    ' Numro du fichier TXT  traiter
Dim Ligne As String             ' Contient la chaine de caractres lue
Dim MetaData As MetaDonnees     ' Enregistrement contenant les mtadonnes des fichiers
Dim LectureDonnees As Boolean   '
'
Dim Info() As Donnees           '
'
Dim CompteurMetadata As Integer ' Nombre de ligne dans un fichier
'
Dim IntituleCol As Boolean      '
Dim CompteurInfo As Long        '
Dim DatePresent As Long         '
Dim NumVerification As Integer  '
Dim Buffer_Date() As String     ' Variable tampon permettant de grer les diffrentes dates
                                ' (Contient le rsultat d'un Split)
Dim Valeur As String            ' Contient une chaine de caractres.
'
Dim MaxLenTitle As Integer      ' Longueur maximale de la chanes de caractres Title
Dim MaxSeriesID As Integer      ' Longueur maximale de la chanes de caractres SeriesID
Dim MaxSource As Integer        ' Longueur maximale de la chanes de caractres Source
Dim MaxRelease As Integer       ' Longueur maximale de la chanes de caractres Release
Dim MaxSeasonAdj As Integer     ' Longueur maximale de la chanes de caractres SeasonAdj
Dim MaxFrequency As Integer     ' Longueur maximale de la chanes de caractres Frequency
Dim MaxUnits As Integer         ' Longueur maximale de la chanes de caractres Units
Dim MaxDateRange As Integer     ' Longueur maximale de la chanes de caractres DateRange
Dim MaxLastUpdated As Integer   ' Longueur maximale de la chanes de caractres LastUpdated
Dim MaxNotes As Integer         ' Longueur maximale de la chanes de caractres Notes
'
Dim rstSERIESmeta As ADODB.Recordset '
Dim rstSeriesTemp As ADODB.Recordset '
Dim rstDonnees As ADODB.Recordset    '
'
' Initialisation des variables
'
MaxLenTitle = 0
MaxSeriesID = 0
MaxSource = 0
MaxRelease = 0
MaxSeasonAdj = 0
MaxFrequency = 0
MaxUnits = 0
MaxDateRange = 0
MaxLastUpdated = 0
MaxNotes = 0
'
Premier = True
NomFichierTXT = " "
NumVerification = FreeFile ' Affectation automatique d'un numro de fichier libre.
'
'   Ecrit dans la fentre "Excution"
'
Debug.Print "Je suis dans Traitement ... "
'
'   Ouverture de la base de donnes.
'
OuvertureBD NomDuFichierDeLaBaseDeDonnees
'
'   Construction de la requte pour obtenir un "recordset"  partir de la table SERIESmeta
'
Set rstSERIESmeta = New ADODB.Recordset
rstSERIESmeta.CursorType = adOpenKeyset
rstSERIESmeta.LockType = adLockOptimistic
rstSERIESmeta.Open "SERIESmeta", cnn, , , adCmdTable
'
'
'
NbMaxFichiers = UBound(ListeFichiers(strDonnees)) + 1
NbMinFichiers = LBound(ListeFichiers(strDonnees))
'
'
'
Debug.Print "NbMaxFichiers = " & NbMaxFichiers
Debug.Print "NbMinFichiers = " & NbMinFichiers

frmExecution.ProgressBar2.Value = 0
frmExecution.ProgressBar2.Max = NbMaxFichiers
frmExecution.ProgressBar2.Min = NbMinFichiers
'
' Boucle sur les noms de fichier
'
Do While NomFichierTXT <> ""
    '
    '   Ecrit dans le fentre d'excution le nom du fichier en cours de traitement.
    '
    Debug.Print "Nom du fichier en cours de traitement = " & NomFichierTXT
    '
    ' Permets  l'ordinateur d'effectuer plusieurs taches en apparence simultanment.
    '
    DoEvents
    '
    ' Recherche du nom de fichier dans le dossier Donnees
    '
    If Premier = True Then
        '
        '   Les deux instructions suivantes servent  lire le premier nom de fichier
        '   contenu dans le dossier strDonnees.
        '
        NomFichierTXT = Dir(RechercheBackSlash(App.Path) & RechercheBackSlash(strDonnees) _
                            & "*.txt")
        Premier = False
    Else
        '
        '   Les instructions suivantes permettent de lire le nom des fichiers contenu
        '   dans le dossier strDonnees une fois le premier fichier lu.
        '   Si la chaine de caractres NomFichierTXT est vide, il y a sortie de la boucle
        '   de traitement.;
        '
        NomFichierTXT = Dir
        If NomFichierTXT = "" Then
            Exit Do
        End If
        '
        '   Permet d'incrmenter le compteur de la ProgressBar2
        '
        frmExecution.ProgressBar2.Value = frmExecution.ProgressBar2.Value + 1
        '
    End If
    '
    '   Ouverture du RecordSet
    '
    '   Ouverture du Recordset rstDonnees
    '
    Set rstDonnees = New ADODB.Recordset
    rstDonnees.CursorType = adOpenKeyset
    rstDonnees.LockType = adLockOptimistic
    rstDonnees.Open "US_" & Left$(NomFichierTXT, Len(NomFichierTXT) - 4), cnn, , , adCmdTable
    '
    ' Construction du nom complet du fichier
    '
    NomFichierTXT_Complet = App.Path & "\" & strDonnees & "\" & NomFichierTXT
    '
    ' Traitement du contenu des fichiers
    '
    '   Initialisation de variables
    '
    NumFichierTxt = FreeFile
    LectureDonnees = False
    '
    '   Ouverture du fichier pour traitement
    '
    Open NomFichierTXT_Complet For Input As #NumFichierTxt
    '
    '   Initialisation des variables.
    '
    IntituleCol = False
    CompteurMetadata = 0
    '
    '   Dbut de la boucle de traitement du contenu des fichiers .TXT.
    '
    Do While Not EOF(NumFichierTxt)
        '
        ' Permets  l'ordinateur d'effectuer plusieurs taches en apparence simultanment.
        '
        DoEvents
        '
        ' Lecture de la ligne  traiter
        '
        Line Input #NumFichierTxt, Ligne
        '
        ' La ligne est-elle vide ?
        '   Si la ligne est vide alors les lignes lues contiendront les donnes
        '   Sinon le ligne contient un metadata sur la srie
        '
        If Ligne = "" Then
            LectureDonnees = True
            '
            '   Recherche de la taille maximale d'un champ.
            '
            MaxLenTitle = MaxLen(MetaData.Title, MaxLenTitle)
            MaxSeriesID = MaxLen(MetaData.SeriesID, MaxSeriesID)
            MaxSource = MaxLen(MetaData.Source, MaxSource)
            MaxRelease = MaxLen(MetaData.Release, MaxRelease)
            MaxSeasonAdj = MaxLen(MetaData.SeasonalAdj, MaxSeasonAdj)
            MaxFrequency = MaxLen(MetaData.Frequency, MaxFrequency)
            MaxUnits = MaxLen(MetaData.Units, MaxUnits)
            MaxDateRange = MaxLen(MetaData.DateRange, MaxDateRange)
            MaxLastUpdated = MaxLen(MetaData.LastUpdated, MaxLastUpdated)
            MaxNotes = MaxLen(MetaData.Notes, MaxNotes)
            '
            ' Ecriture dans le recordset
            '
            rstSERIESmeta.AddNew
                rstSERIESmeta!Country = "US"
                rstSERIESmeta!Title = MetaData.Title
                rstSERIESmeta!SeriesID = MetaData.SeriesID
                rstSERIESmeta!Source = MetaData.Source
                rstSERIESmeta!Release = MetaData.Release
                rstSERIESmeta!Seasonal = MetaData.SeasonalAdj
                rstSERIESmeta!Frequency = MetaData.Frequency
                rstSERIESmeta!Units = MetaData.Units
                rstSERIESmeta!Date = MetaData.DateRange
                rstSERIESmeta!Date_First = MetaData.Date_First
                rstSERIESmeta!Date_Last = MetaData.Date_Last
                rstSERIESmeta!LastUpdate = MetaData.LastUpdated
                rstSERIESmeta!Note = MetaData.Notes
            rstSERIESmeta.Update
            '
        End If
        '
        '   Traitement des metadata de la serie contenu dans le fichier
        '   en cours de traitement
        '
        If LectureDonnees = False Then
            '
            ' Traitement ligne  ligne
            '
            '   Mise en place d'un compteur de ligne
            '
            CompteurMetadata = CompteurMetadata + 1
            '
            ' Affectation du contenu de chaque ligne
            '
            Select Case CompteurMetadata
                Case 1
                    MetaData.Title = Intitule(Ligne, ":")
                Case 2
                    MetaData.SeriesID = Intitule(Ligne, ":")
                Case 3
                    MetaData.Source = Intitule(Ligne, ":")
                Case 4
                    MetaData.Release = Intitule(Ligne, ":")
                Case 5
                    MetaData.SeasonalAdj = Intitule(Ligne, ":")
                Case 6
                    MetaData.Frequency = Intitule(Ligne, ":")
                Case 7
                    MetaData.Units = Intitule(Ligne, ":")
                Case 8
                    MetaData.DateRange = Intitule(Ligne, ":")
                    Buffer_Date = Split(MetaData.DateRange, " to ")
                    MetaData.Date_First = CDate(Buffer_Date(0))
                    MetaData.Date_Last = CDate(Buffer_Date(1))
                Case 9
                    MetaData.LastUpdated = Intitule(Ligne, ":")
                Case 10
                    MetaData.Notes = Intitule(Ligne, ":")
                Case 11 To 20
                    MetaData.Notes = MetaData.Notes & vbCrLf & Trim$(Ligne)
            End Select
        Else
            If IntituleCol = False Then
                DatePresent = InStr(1, Ligne, "DATE", vbTextCompare)
                If DatePresent <> 0 Then
                    IntituleCol = True
                    CompteurInfo = 0
                End If
            Else
                ReDim Preserve Info(CompteurInfo)
                '
                ' Les dates sont fixes en taille : 10 caractres.
                '
                Info(CompteurInfo).Date = Left$(Ligne, 10)
                
                Valeur = Trim$(Right$(Ligne, Len(Ligne) - 10))
                
                If Len(Valeur) <> 1 Then
                    Info(CompteurInfo).Valeur = CDbl(Valeur)
                Else
                    Info(CompteurInfo).Valeur = -999999.99
                End If
                
                rstDonnees.AddNew
        
                rstDonnees!Date = Info(CompteurInfo).Date
                rstDonnees!Value = Info(CompteurInfo).Valeur
                
                rstDonnees.Update

                CompteurInfo = CompteurInfo + 1
            End If
        End If
        '
        ' Fin du traitement du contenu du fichier en cours de traitement
        '
        ' Permets  l'ordinateur d'effectuer plusieurs taches en apparence simultanment.
        '
        DoEvents
        '
        '   Remplissage de la base de donnes
        '
    Loop
    '
    ' Fermeture du fichier en lecture
    '
    rstDonnees.Close
    Set rstDonnees = Nothing
    '
    Close NumFichierTxt
    '
    ' Le fichier ayant t trait, il n'a plus raison d'tre sur le disque
    '
    Kill NomFichierTXT_Complet
    '
    ' Fin de la boucle portant sur tous les fichiers contenus dans le dossier des donnes
    '
Loop
'
'   Ecrit dans la fentre "Execution" - Phase de test.
'
Debug.Print "MaxLenTitle = " & MaxLenTitle
Debug.Print "MaxSeriesID = " & MaxSeriesID
Debug.Print "MaxSource = " & MaxSource
Debug.Print "MaxRelease = " & MaxRelease
Debug.Print "MaxSeasonAdj = " & MaxSeasonAdj
Debug.Print "MaxFrequency = " & MaxFrequency
Debug.Print "MaxUnits = " & MaxUnits
Debug.Print "MaxDateRange = " & MaxDateRange
Debug.Print "MaxLastUpdated = " & MaxLastUpdated
Debug.Print "MaxNotes = " & MaxNotes
'
'   Fermeture des objets
'
rstSERIESmeta.Close
cnn.Close
'
'   Libration des ressources "mmoire" et "systme" associes  l'objet.
'
Set rstSERIESmeta = Nothing
Set cnn = Nothing
'
' Ecrit dans le fentre "Execution" - Phase de test
'
Debug.Print "Fin de traitement"
'
' Fin du sous-programme traitement
'
End Sub
