Attribute VB_Name = "Graph"
Option Explicit

Public Sub createChart(viewer As Object, img As String, Hauteur As Integer, _
                       Largeur As Integer)
'
'----------------------------------------------------------------------------------------
'   Sous programme creatChart
'----------------------------------------------------------------------------------------
'
'   Ce sous-programme est une version adapte de l'exemple fourni avec ChartDirector.
'   Son adaptation consiste principalement en une lecture des donnes  partir de
'   la base de donnes construites  partir des donnes de la FRB de Saint Louis.
'
'----------------------------------------------------------------------------------------
'
'----------------------------------------------------------------------------------------
'
'   Dclarations des variables
'
Dim cd As New ChartDirector.API '
Dim data0()                     '
Dim labels()                    '
'
Dim Compteur As Integer         '
'
Dim Titre As String             '
Dim YAxisTitle As String        '
Dim Frequency As String         '
Dim Mnemonique As String        '

Dim c As XYChart                '
'
'Dim Largeur As Integer          ' Largeur de l'espace de l'image (Width).
'Dim Hauteur As Integer          ' Hauteur de l'espace de l'image (Height).
Dim Top As Integer              ' Taille de l'espace entre le haut de l'image et le point
                                ' o l'image du graphique est crit (Top).
Dim Gauche  As Integer           ' Espace entre l'espace de l'image et la marge gauche (Left).
'
'   Initialisation des dimensions utilises dans le sous-programme
'
'Largeur = 1024   '
'Hauteur = 768  '
Top = 45        '
Gauche = 55     '
'
'   Affectation  des variables des informations contenues dans la base de donnes et
'   ncessaires  la cration du graphique.
'
rsSERIES.MoveFirst
'
Titre = rsSERIES!Title
YAxisTitle = rsSERIES!Units
Frequency = rsSERIES!Frequency
Mnemonique = rsSERIES!SeriesID
'
'   Affectation des donnes et des dates contenues dans la table de la variables
'   slectionnes
'
rsMonetaryData.MoveFirst
'
Do While Not rsMonetaryData.EOF
    ReDim Preserve data0(Compteur)
    ReDim Preserve labels(Compteur)
    '
    data0(Compteur) = rsMonetaryData!Value
    labels(Compteur) = rsMonetaryData!Date
    '
    rsMonetaryData.MoveNext
    '
    Compteur = Compteur + 1
Loop
'
'   Cration d'un graphique de type XYChart de la taille de Largeur x Hauteur pixels,
'   avec un fond en jaune ple (0xffff80), une bordure noire et un effet de bordure 3d
'   de 1 pixel.
'
Set c = cd.XYChart(Largeur, Hauteur, &HFFFF80, &H0, 1)
'
'   Dfini la zne de tracer du graphique  partir de (Gauche, Top) et avec une taille
'   Largeur - 2 * Gauche, Hauteur - 2 * Top pixelq, avec un fond blanc. Avec des lignes de
'   grilles verticales et horizontales en gris clair (0xc0c0c0).
'
Call c.setPlotArea(Gauche, Top, Largeur - 2 * Gauche, Hauteur - 2 * Top, &HFFFFFF, -1, -1, &HC0C0C0, -1)
'
'   Ajoute une bote de lgende  (55,25) avec une prsentation horizontale. La fonte est
'   Arial 8 points. Les couleurs du fond et de la bordure sont dfinis en transparent.
'
Call c.addLegend(55, 25, False, "", 8).setBackground(cd.Transparent)
'
'   Ajoute un bote de titre utilisant une fonte Arial 11 points Itakique Gras. Le texte
'   est blanc (0xffffff) sur une fond en rouge fonc (0x800000), avec une bordure en
'   3D de 1 pixel.
'
Call c.addTitle(Titre, "arialbi.ttf", 12, &HFFFFFF).setBackground(&H800000, -1, 1)
'
'   Ajoute un titre  l'axe des y
'
Call c.yAxis().setTitle(YAxisTitle)
'
'
'
Call c.yAxis().setAutoScale(0.005, 0.001, 0.01)
'
'   Dfini les tiquettes de l'axe des x.
'
Call c.xAxis().setLabels(labels)
'
'   Montre une tiquette sur trois sur l'axe des x.
'
Call c.xAxis().setLabelStep(90)
'
'   Ajoute un titre  l'axe des x.
'
Call c.xAxis().setTitle("Time - " & Frequency)
'
'Add a line layer to the chart
'
Dim layer As LineLayer
Set layer = c.addLineLayer2()
'
'   Dfini la largeur de la ligne par dfaut  2 pixels
'
Call layer.setLineWidth(2)
'
'   Ajoute les trois jeux de donnes au line layer. Dans un objectif de dmo, nous
'   avons utilis une ligne pointille colore pour la dernier ligne.
'
Call layer.addDataSet(data0, -1, DataSeries)
'
'Call layer.addDataSet(data1, -1, "Server # 2")
'Call layer.addDataSet(data2, c.dashLineColor(&H3333FF, cd.DashLine), "Server # 3")
'
'   Sortie du graphique.
'
Set Graphiques.viewer.Picture = c.makePicture()
'
'   Inclut un "tool tip" pour le graphique
'Graphiques.viewer.ImageMap = c.getHTMLImageMap("clickable", "", "title='[{dataSetName}] Hour {xLabel}: {value} MBytes'")
'
'rsSERIES.Close
'Set rsSERIES = Nothing
'
'
'
End Sub
 



