Attribute VB_Name = "Donnees"
Option Explicit
Option Base 0

Public Function X(NomFichierDonnees As String) As Double()
'
'----------------------------------------------------------------------------------------
' Lecture des donnes - construction de la matrice X
'----------------------------------------------------------------------------------------
'
' Pour utiliser Regression, il faut construire une matrice X. Cette fonction construit
' cette matrice  partir de fichier ayant pour structure :
'
' NVI NO Constante
' Donnes
' ;
'
' Ici, les donnes sont spares par des blancs.
'
'----------------------------------------------------------------------------------------
'  Fvrier 2003 - Paul Salmon
'----------------------------------------------------------------------------------------
'
' Arguments
'
' NomFichierDonnees        ' Le nom est construit dans la fonction ou sous-programme
                           ' appelant LectureDonnees
'
' Dclarations des variables locales.
'
Dim MatX() As Double       ' Matrice X augmente
                           ' Cette matrice contient les NVI variables explicatives
                           ' de la colonne 0  la colonne NVI - 1 et la variable 
                           ' expliquer dans la NC ime colonne de la matrice.
                           ' NC = NVI + 1. Les lignes sont au nombre de NO.
                           ' La premire ligne  pour indice 0. La matrice X est
                           ' dfinie comme suit: X( 0 To No - 1 , 0 to NC - 1 )
Dim Compteur As Long       ' Variable contenant le numro de la ligne en cours de lecture.
Dim CONSTANTE As String    ' Variable indiquant si X contient en premire colonne des 1.
Dim DataLigne() As String    ' Vecteur tampon contenant les rsultats de la fonction Split
Dim i As Long              ' Indice de boucle
Dim j As Long              ' Indice de Boucle
Dim LigneDeTexte As String ' Ligne lue dans le fichier en cours de traitement
Dim NC As Long             ' Nombre de variables explicatives plus la variable dpendante
Dim NO As Long             ' Nombre d'observations
Dim NVI As Long            ' Nombre de variables indpendantes
'
' Ouverture du fichier contenant les donnes  introduire dans la matrice.
'
Open NomFichierDonnees For Input As #1
'
' Initialisation du compteur du nombre de ligne lue
'
Compteur = 0
'
Do While Not EOF(1)
    '
    ' Incrmentation du compteur
    '
    Compteur = Compteur + 1
    '
    ' Lecture de la ligne du fichier ASCII
    '
    Line Input #1, LigneDeTexte
    '
    ' Prise en compte du contenu de la premire ligne du fichier lu.
    '
    If Compteur = 1 Then
        '
        ' Recherche  et affectations des information de la premire ligne.
        '
        '   Recherche
        '
        DataLigne = Split(SubstitutionCaractereConsecutif(LigneDeTexte, " "), " ", -1, vbTextCompare)
        '
        '   Affectation des valeurs contenues dans DataLigne
        '
        NVI = DataLigne(0)
        NO = DataLigne(1)
        CONSTANTE = DataLigne(2)
        Debug.Print "NVI = " & NVI & " NO = " & NO & " CONSTANTe = " & CONSTANTE
        '
        ' Dimensionnement de la matrice X en fonction des informations lues dans
        ' le fichier de donnes
        '
        If CONSTANTE = "True" Then
            '
            ' Cas de l'introduction d'une constante dans la matrice (cas gnral)
            '
            ReDim MatX(0 To NO - 1, 0 To NVI + 1)
            '
        Else
            '
            ' Cas o la matrice ne contient pas de constante. Dans ce cas les
            ' rsultats de Regression ne correspondent pas  ce cas.
            '
            ReDim MatX(0 To NO - 1, 0 To NVI)
            '
            ' Message d'avertissement
            '
            MsgBox "Attention : Compte tenu de votre choix d'absence de constante dans X," & vbCrLf & _
                   "les calculs obtenus avec Regression seront pour certains erronns.", vbCritical
            '
        End If
        '
        ' Initialisation de la matrice X
        '
        ' Si constante = True, alors introduction de la constante dans le colonne 0 de X
        ' et zro dans toutes les autres solonnes.
        ' Sinon toutes les colonnes de la matrice seront initialises  0.
        '
        For j = 0 To UBound(MatX, 2) - 1
                If (j = 0) And (CONSTANTE = True) Then
                    For i = 0 To UBound(MatX, 1)
                        MatX(i, j) = 1#
                    Next i
                Else
                    For i = 0 To UBound(MatX, 1) - 1
                        MatX(i, j) = 0#
                    Next i
                End If
        Next j
        '
    ElseIf Compteur > 1 And Compteur <= NO + 1 Then
        '
        '   Cration du vecteur DataLigne contenant les donnes sur la ligne
        '
        DataLigne = Split(Trim(SubstitutionCaractereConsecutif(LigneDeTexte, " ")), _
                          " ", -1, vbTextCompare)
        Dim kkk As Integer
        For kkk = 0 To UBound(DataLigne)
            Debug.Print DataLigne(kkk)
        Next kkk
        '
        ' Remplissage des colonnes, ligne par ligne
        ' L'itration dbute en 1 car la colonne 0 contient les valeur de la constante
        '
        Debug.Print "Compteur avant = " & Compteur
        For j = 0 To UBound(MatX, 2)
            If CONSTANTE = "True" Then
                If j <> UBound(MatX, 2) Then
                    MatX(Compteur - 2, j + 1) = Val(DataLigne(j))
                End If
            Else
                MatX(Compteur - 2, j) = Val(DataLigne(j))
            End If
            '
        Next j
        '
    Else
        '
        ' Gestion des autres cas. Sortie de la boucle.
        '
        Exit Do
        '
    End If
Loop
'
X = MatX
'
End Function


