Attribute VB_Name = "Principal"
Option Explicit


Public Sub Main()
'
'
'
Dim fso As New FileSystemObject    '
Dim Fichier As File                '
Dim FichierEcriture As TextStream  '
Dim Dossier As Folder              '
Dim FluxTexte As TextStream        '
Dim ChaineCaracteres
'
Dim NomFichierBaseConfig As String '

'
'
'
NomFichierBaseConfig = App.Path & "\config\" & "word_basic.cfg"
Debug.Print NomFichierBaseConfig
'
'   Existe-il un fichier de configuration de base (word_basic.cfg).
'   Ce fichier est situ dans le dossier config du chemin de l'aplication
'
If fso.FileExists(NomFichierBaseConfig) Then
    '
    '   Le fichier existe
    '
    Debug.Print "Le fichier existe"
    '
    '   Lire le fichier
    '
    '       Ouverture du fichier
    '
    Set Fichier = fso.OpenTextFile(NomFichierBaseConfig, ForReading)
    Set FluxTexte = Fichier.OpenAsTextStream(ForReading, TristateUseDefault)
    ChaineCaracteres = FluxTexte.ReadAll
    Debug.Print ChaineCaracteres
    ChaineCaracteres.Close
    '
    '
    '
Else
    '
    '   Le fichier n'existe pas
    '
    
    '
    '   Crer le fichier de base
    '
    Set FichierEcriture = fso.CreateTextFile(NomFichierBaseConfig, ForWriting)
    With FichierEcriture
        .WriteLine "'"
        .WriteLine "'--------------------"
        .WriteLine "'"
        .WriteLine "'--------------------"
        .WriteLine "Existe; True"
        .WriteLine "G7 - Test d'utilisation"
        .WriteLine "X12 - Test Utilisation"
    End With
End If


End

If Configuration = False Then
    End
End If
'
Set MonAppli = New Word.Application
Set MonDocument = New Word.Document
'
Word_Basic.Show
End Sub

Public Function Configuration() As Boolean
'
'----------------------------------------------------------------------------------------
'   Configuration
'----------------------------------------------------------------------------------------
'
'   Cette fonction permet de lire et d'initialiser les diffrentes valeurs des variables
'   lues dans le fichier de configuration (config.cfg) contenu dans le dossier de
'   l'application.
'
'----------------------------------------------------------------------------------------
'    Aot 2006 - Paul Salmon
'----------------------------------------------------------------------------------------
'
'   Dclarations locales
'
Dim fso As New FileSystemObject   '
Dim Fichier As File               '
Dim ts As TextStream              '
Dim s As String                   '
Dim Compteur As Integer           '
Dim Buffer As Variant             '
Dim BoolChemin As Boolean         '
Dim BoolDossierWord As Boolean    '
Dim BoolDossierImages As Boolean  '
Dim BoolDossierTextes As Boolean  '
Dim BoolAutre As Boolean          '
'
'   Initialisation des variables boolennes.
'
BoolChemin = False
BoolDossierWord = False
BoolDossierImages = False
BoolDossierTextes = False
BoolAutre = True
'
'   Ouverture du fichier de Configuration.
'
Set Fichier = fso.GetFile(App.Path & "\" & "config.cfg")
Set ts = Fichier.OpenAsTextStream(ForReading, TristateUseDefault)
Compteur = 0
Do While Not ts.AtEndOfStream
Debug.Print "compteur = " & Compteur

s = ts.ReadLine
Debug.Print s

If InStr(1, s, "#", vbTextCompare) = 0 Then
    Compteur = Compteur + 1
    Buffer = Split(s, ";", -1, vbTextCompare)
    Select Case Compteur
        Case 1
            Chemin = Trim(Buffer(1))
            If Len(Chemin) <> 0 Then
                BoolChemin = True
            End If
        Case 2
            DossierWord = Trim(Buffer(1))
            If Len(DossierWord) <> 0 Then
                BoolDossierWord = True
            End If
        Case 3
            DossierImages = Trim(Buffer(1))
            If Len(DossierImages) <> 0 Then
                BoolDossierImages = True
            End If
        Case 4
            DossierTextes = Trim(Buffer(1))
            If Len(DossierTextes) <> 0 Then
                BoolDossierTextes = True
            End If
        Case Else
            MsgBox "Il n'y a pas de cas pour cela"
    End Select
End If
Loop
'
'   Vrification de la bonne lecture des informations  lire dans le fichier config.cfg
'
Debug.Print Chemin
Debug.Print DossierWord
Debug.Print DossierImages
Debug.Print DossierTextes
'
'   Affectation de la valeur de Configuration
'
If BoolChemin = True And BoolDossierWord = True And BoolDossierImages = True And _
    BoolDossierTextes = True And BoolAutre = True Then
    Configuration = True
Else
    Configuration = False
End If
'
'----------------------------------------------------------------------------------------
'   Fin de la fonction Configuration.
'----------------------------------------------------------------------------------------
'
End Function

Public Function UpdateConfig() As Boolean
'
'----------------------------------------------------------------------------------------
'   UpdateConfig
'----------------------------------------------------------------------------------------
'
'   Cette fonction permet de lire et d'initialiser les diffrentes valeurs des variables
'   lues dans le fichier de configuration (config.cfg) contenu dans le dossier de
'   l'application.
'
'----------------------------------------------------------------------------------------
'    Aot 2006 - Paul Salmon
'----------------------------------------------------------------------------------------
'
'   Dclarations locales
'
Dim fso As New FileSystemObject   '
Dim Fichier As File               '
Dim ts As TextStream              '
Dim s As String                   '
Dim Compteur As Integer           '
Dim Buffer As Variant             '
Dim BoolChemin As Boolean         '
Dim BoolDossierWord As Boolean    '
Dim BoolDossierImages As Boolean  '
Dim BoolDossierTextes As Boolean  '
Dim BoolAutre As Boolean          '
'
'   Initialisation des variables boolennes.
'
BoolChemin = False
BoolDossierWord = False
BoolDossierImages = False
BoolDossierTextes = False
BoolAutre = True
'
'   Ouverture du fichier de Configuration.
'
Set Fichier = fso.GetFile(App.Path & "\" & "config.cfg")
Set ts = Fichier.OpenAsTextStream(ForReading, TristateUseDefault)
Compteur = 0
Do While Not ts.AtEndOfStream
Debug.Print "compteur = " & Compteur

s = ts.ReadLine
Debug.Print s

If InStr(1, s, "#", vbTextCompare) = 0 Then
    Compteur = Compteur + 1
    Buffer = Split(s, ";", -1, vbTextCompare)
    Select Case Compteur
        Case 1
            Chemin = Trim(Buffer(1))
            If Len(Chemin) <> 0 Then
                BoolChemin = True
            End If
        Case 2
            DossierWord = Trim(Buffer(1))
            If Len(DossierWord) <> 0 Then
                BoolDossierWord = True
            End If
        Case 3
            DossierImages = Trim(Buffer(1))
            If Len(DossierImages) <> 0 Then
                BoolDossierImages = True
            End If
        Case 4
            DossierTextes = Trim(Buffer(1))
            If Len(DossierTextes) <> 0 Then
                BoolDossierTextes = True
            End If
        Case Else
            MsgBox "Il n'y a pas de cas pour cela"
    End Select
End If
Loop
'
'   Affectation de la valeur de Configuration
'
If BoolChemin = True And BoolDossierWord = True And BoolDossierImages = True And _
    BoolDossierTextes = True And BoolAutre = True Then
    UpdateConfig = True
    '
    '   Stockage des informations lues dans le fichier config.cfg
    '
    OldConfigText(0) = Chemin
    OldConfigText(1) = DossierWord
    OldConfigText(2) = DossierImages
    OldConfigText(3) = DossierTextes
    '
    '
    '
Else
    UpdateConfig = False
End If
'
'----------------------------------------------------------------------------------------
'   Fin de la fonction Configuration.
'----------------------------------------------------------------------------------------
'
End Function

